
# line 2 "calc.y"

/**********************************************************************
 * $Id: calc.y,v 1.3 93/03/29 14:15:41 drew Exp $
 **********************************************************************/

/**********************************************************************
 *   Copyright 1990,1991,1992,1993 by The University of Toronto,
 *		       Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute,  and sell this software
 * and its documentation for any purpose is hereby granted without fee,
 * provided  that the above copyright notice  appears in all copies and
 * that both the copyright notice and this permission notice  appear in
 * supporting documentation, and  that  the  name of The University  of
 * Toronto  not  be used  in advertising   or publicity pertaining   to
 * distribution  of   the software   without  specific, written   prior
 * permission.  The  University  of Toronto  makes   no representations
 * about the  suitability  of  this software  for  any purpose.   It is
 * provided "as is" without express or implied warranty.
 *
 * THE  UNIVERSITY OF  TORONTO DISCLAIMS ALL WARRANTIES  WITH REGARD TO
 * THIS SOFTWARE,  INCLUDING ALL  IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS, IN NO EVENT  SHALL THE UNIVERSITY  OF TORONTO BE LIABLE
 * FOR ANY SPECIAL,  INDIRECT OR CONSEQUENTIAL  DAMAGES  OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF  USE, DATA OR PROFITS,  WHETHER IN
 * AN ACTION OF CONTRACT, NEGLIGENCE  OR OTHER TORTIOUS ACTION, ARISING
 * OUT  OF OR  IN  CONNECTION   WITH  THE  USE OR  PERFORMANCE  OF THIS
 * SOFTWARE.
 **********************************************************************/

#include <xerion/config.h>
#include <math.h>
#include "itf.h"

/***********************************************************************
 * We need all of these because they're GLOBALS, so we get name 
 * conflicts with anything else that uses yacc. A stupid irritating hack,
 * but I can't see any other way around it. The only problem is that I'm
 * not sure that every version of yacc uses the same variable names.
 ***********************************************************************/
#define yyparse() 	yyparseCalc()
#define yychar	 	yycharCalc
#define yyerrflag	yyerrflagCalc
#define yyval		yyvalCalc
#define yyexca		yyexcaCalc
#define yyact		yyactCalc
#define yypact		yypactCalc
#define yypgo		yypgoCalc
#define yyr1		yyr1Calc
#define yyr2		yyr2Calc
#define yychk		yychkCalc
#define yydef		yydefCalc
#define yydebug		yydebugCalc
#define yyv		yyvCalc
#define yys		yysCalc
#define yypv		yypvCalc
#define yyps		yypsCalc
#define yystate		yystateCalc
#define yytmp		yytmpCalc
#define yynerrs		yynerrsCalc
#define yymaxdepth	yymaxdepthCalc
/***********************************************************************/
#define YYSTYPE double		/* data typ of yacc stack */
/***********************************************************************/
# define NUMBER 257
# define ABS 258
# define SQRT 259
# define LOG 260
# define EXP 261
# define SIN 262
# define COS 263
# define TAN 264
# define SINH 265
# define COSH 266
# define TANH 267
# define SIGMOID 268
# define OR 269
# define AND 270
# define EQ 271
# define NE 272
# define GT 273
# define GE 274
# define LT 275
# define LE 276
# define UNARYMINUS 277
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#ifndef YYSTYPE
#define YYSTYPE int
#endif
YYSTYPE yylval, yyval;
typedef int yytabelem;
#include <stdio.h>
# define YYERRCODE 256
yytabelem yyexca[] ={
	-1, 1,
	0, -1,
	-2, 0,
	};
# define YYNPROD 32
# define YYLAST 495
yytabelem yyact[]={

    21,    22,    44,     1,    83,    19,    17,    43,    18,    21,
    20,    21,     0,    82,    19,    17,    19,    18,    42,    20,
    41,    20,    40,    21,    39,    38,    31,    81,    19,    17,
    37,    18,    21,    20,    36,    31,    80,    19,    17,    35,
    18,    34,    20,     0,     0,     0,    21,     0,     0,    31,
    79,    19,    17,     0,    18,    21,    20,    22,    31,    78,
    19,    17,     0,    18,     0,    20,    22,     0,    22,    21,
     0,     0,    31,    77,    19,    17,     0,    18,    21,    20,
    22,    31,    76,    19,    17,     0,    18,     0,    20,    22,
     0,     0,    21,     0,     0,    31,    75,    19,    17,     0,
    18,    21,    20,    22,    31,    74,    19,    17,     0,    18,
     0,    20,    22,     0,     0,    21,     0,     0,    31,    73,
    19,    17,     0,    18,    21,    20,    22,    31,     0,    19,
    17,     0,    18,     0,    20,    22,     0,     0,    21,     0,
     0,    31,    60,    19,    17,    72,    18,    21,    20,    22,
    31,     0,    19,    17,     0,    18,     0,    20,    22,     0,
    21,     0,     0,     0,    31,    19,    17,     0,    18,    21,
    20,     0,    22,    31,    19,    17,     0,    18,     0,    20,
     0,    22,     0,    21,     0,     0,     0,     0,    19,    17,
     0,    18,     5,    20,     0,    22,     0,     4,     0,     0,
     0,     0,     0,     0,    22,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    22,     0,     0,
     0,     0,     0,     0,     0,     0,    22,     0,     0,     0,
     0,     0,    29,    30,    23,    24,    25,    26,    27,    28,
    22,    29,    30,    23,    24,    25,    26,    27,    28,     0,
     0,     0,     0,     0,     0,    29,    30,    23,    24,    25,
    26,    27,    28,     0,    29,    30,    23,    24,    25,    26,
    27,    28,     0,     0,     0,     0,     0,     0,    29,    30,
    23,    24,    25,    26,    27,    28,     0,    29,    30,    23,
    24,    25,    26,    27,    28,     0,     0,     0,     0,     0,
     0,    29,    30,    23,    24,    25,    26,    27,    28,     0,
    29,    30,    23,    24,    25,    26,    27,    28,     0,     0,
     0,     0,     0,     0,    29,    30,    23,    24,    25,    26,
    27,    28,     0,    29,    30,    23,    24,    25,    26,    27,
    28,     0,     0,     0,     0,     0,     0,    29,    30,    23,
    24,    25,    26,    27,    28,     0,    29,    30,    23,    24,
    25,    26,    27,    28,     0,     0,     0,     0,     0,     0,
    29,    30,    23,    24,    25,    26,    27,    28,     0,    29,
    30,    23,    24,    25,    26,    27,    28,     0,     0,     0,
     0,     0,     0,    30,    23,    24,    25,    26,    27,    28,
     0,     0,     0,    23,    24,    25,    26,    27,    28,     3,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,     2,     0,     0,     0,     0,    32,    33,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,     0,     0,    61,    62,    63,    64,
    65,    66,    67,    68,    69,    70,    71,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    84 };
yytabelem yypact[]={

 -1000,   152,   110, -1000,   152,   152,     1,    -1,    -6,   -10,
   -15,   -16,   -18,   -20,   -22,   -33,   -38,   152,   152,   152,
   152,   152,   152,   152,   152,   152,   152,   152,   152,   152,
   152,   152,   -93,   101,   152,   152,   152,   152,   152,   152,
   152,   152,   152,   152,   152,   -26,   -26,   -93,   -93,   -93,
   -93,   146,   146,   146,   146,   146,   146,   123,   132,    87,
 -1000,    78,    64,    55,    41,    32,    18,     9,    -5,   -14,
   -28,   -37,   152, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000, -1000,   110 };
yytabelem yypgo[]={

     0,     3,   421 };
yytabelem yyr1[]={

     0,     1,     1,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2 };
yytabelem yyr2[]={

     0,     0,     5,     3,     5,     7,     7,     7,     7,     7,
     7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
    11,     9,     9,     9,     9,     9,     9,     9,     9,     9,
     9,     9 };
yytabelem yychk[]={

 -1000,    -1,    -2,   257,    45,    40,   258,   259,   260,   261,
   262,   263,   264,   265,   266,   267,   268,    43,    45,    42,
    47,    37,    94,   271,   272,   273,   274,   275,   276,   269,
   270,    63,    -2,    -2,    40,    40,    40,    40,    40,    40,
    40,    40,    40,    40,    40,    -2,    -2,    -2,    -2,    -2,
    -2,    -2,    -2,    -2,    -2,    -2,    -2,    -2,    -2,    -2,
    41,    -2,    -2,    -2,    -2,    -2,    -2,    -2,    -2,    -2,
    -2,    -2,    58,    41,    41,    41,    41,    41,    41,    41,
    41,    41,    41,    41,    -2 };
yytabelem yydef[]={

     1,    -2,     2,     3,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     4,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     5,     6,     7,     8,     9,
    10,    12,    13,    14,    15,    16,    17,    18,    19,     0,
    11,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    21,    22,    23,    24,    25,    26,    27,
    28,    29,    30,    31,    20 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

char * yyreds[] =
{
	"-no such reduction-",
      "list : /* empty */",
      "list : list expr",
      "expr : NUMBER",
      "expr : '-' expr",
      "expr : expr '+' expr",
      "expr : expr '-' expr",
      "expr : expr '*' expr",
      "expr : expr '/' expr",
      "expr : expr '%' expr",
      "expr : expr '^' expr",
      "expr : '(' expr ')'",
      "expr : expr EQ expr",
      "expr : expr NE expr",
      "expr : expr GT expr",
      "expr : expr GE expr",
      "expr : expr LT expr",
      "expr : expr LE expr",
      "expr : expr OR expr",
      "expr : expr AND expr",
      "expr : expr '?' expr ':' expr",
      "expr : ABS '(' expr ')'",
      "expr : SQRT '(' expr ')'",
      "expr : LOG '(' expr ')'",
      "expr : EXP '(' expr ')'",
      "expr : SIN '(' expr ')'",
      "expr : COS '(' expr ')'",
      "expr : TAN '(' expr ')'",
      "expr : SINH '(' expr ')'",
      "expr : COSH '(' expr ')'",
      "expr : TANH '(' expr ')'",
      "expr : SIGMOID '(' expr ')'",
};
yytoktype yytoks[] =
{
	"NUMBER",	257,
	"ABS",	258,
	"SQRT",	259,
	"LOG",	260,
	"EXP",	261,
	"SIN",	262,
	"COS",	263,
	"TAN",	264,
	"SINH",	265,
	"COSH",	266,
	"TANH",	267,
	"SIGMOID",	268,
	"':'",	58,
	"'?'",	63,
	"OR",	269,
	"AND",	270,
	"EQ",	271,
	"NE",	272,
	"GT",	273,
	"GE",	274,
	"LT",	275,
	"LE",	276,
	"'+'",	43,
	"'-'",	45,
	"'*'",	42,
	"'/'",	47,
	"'%'",	37,
	"UNARYMINUS",	277,
	"'^'",	94,
	"'('",	40,
	"')'",	41,
	"-unknown-",	-1	/* ends search */
};
#endif /* YYDEBUG */

/* @(#)27       1.7.1.3  src/bos/usr/ccs/bin/yacc/yaccpar, cmdlang, bos411, 9432B411a 8/10/94 14:01:53 */
/*
 * COMPONENT_NAME: (CMDLANG) Language Utilities
 *
 * FUNCTIONS: yyparse
 * ORIGINS: 3
 */
/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#ifdef YYSPLIT
#   define YYERROR      return(-2)
#else
#   define YYERROR      goto yyerrlab
#endif
#ifdef YACC_MSG
#ifndef _XOPEN_SOURCE
#define _XOPEN_SOURCE
#endif
#include <nl_types.h>
nl_catd yyusercatd;
#endif
#define YYACCEPT        return(0)
#define YYABORT         return(1)
#ifndef YACC_MSG
#define YYBACKUP( newtoken, newvalue )\
{\
        if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
        {\
                yyerror( "syntax error - cannot backup" );\
                YYERROR;\
        }\
        yychar = newtoken;\
        yystate = *yyps;\
        yylval = newvalue;\
        goto yynewstate;\
}
#else
#define YYBACKUP( newtoken, newvalue )\
{\
        if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
        {\
                yyusercatd=catopen("yacc_user.cat", NL_CAT_LOCALE);\
                yyerror(catgets(yyusercatd,1,1,"syntax error - cannot backup" ));\
                YYERROR;\
        }\
        yychar = newtoken;\
        yystate = *yyps;\
        yylval = newvalue;\
        goto yynewstate;\
}
#endif
#define YYRECOVERING()  (!!yyerrflag)
#ifndef YYDEBUG
#       define YYDEBUG  1       /* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;                    /* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG          (-1000)

#ifdef YYSPLIT
#   define YYSCODE { \
                        extern int (*_yyf[])(); \
                        register int yyret; \
                        if (_yyf[yytmp]) \
                            if ((yyret=(*_yyf[yytmp])()) == -2) \
                                    goto yyerrlab; \
                                else if (yyret>=0) return(yyret); \
                   }
#endif

/*
** global variables used by the parser
*/
YYSTYPE yyv[ YYMAXDEPTH ];      /* value stack */
int yys[ YYMAXDEPTH ];          /* state stack */

YYSTYPE *yypv;                  /* top of value stack */
YYSTYPE *yypvt;                 /* top of value stack for $vars */
int *yyps;                      /* top of state stack */

int yystate;                    /* current state */
int yytmp;                      /* extra var (lasts between blocks) */

int yynerrs;                    /* number of errors */
int yyerrflag;                  /* error recovery flag */
int yychar;                     /* current input token number */

#ifdef __cplusplus
 #ifdef _CPP_IOSTREAMS
  #include <iostream.h>
  extern void yyerror (char *); /* error message routine -- iostream version */
 #else
  #include <stdio.h>
  extern "C" void yyerror (char *); /* error message routine -- stdio version */
 #endif /* _CPP_IOSTREAMS */
 extern "C" int yylex(void);        /* return the next token */
#endif /* __cplusplus */


/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
#ifdef __cplusplus
extern "C"
#endif /* __cplusplus */
int
yyparse()
{
        /*
        ** Initialize externals - yyparse may be called more than once
        */
        yypv = &yyv[-1];
        yyps = &yys[-1];
        yystate = 0;
        yytmp = 0;
        yynerrs = 0;
        yyerrflag = 0;
        yychar = -1;
#ifdef YACC_MSG
        yyusercatd=catopen("yacc_user.cat", NL_CAT_LOCALE);
#endif
        goto yystack;
        {
                register YYSTYPE *yy_pv;        /* top of value stack */
                register int *yy_ps;            /* top of state stack */
                register int yy_state;          /* current state */
                register int  yy_n;             /* internal state number info */

                /*
                ** get globals into registers.
                ** branch to here only if YYBACKUP was called.
                */
        yynewstate:
                yy_pv = yypv;
                yy_ps = yyps;
                yy_state = yystate;
                goto yy_newstate;

                /*
                ** get globals into registers.
                ** either we just started, or we just finished a reduction
                */
        yystack:
                yy_pv = yypv;
                yy_ps = yyps;
                yy_state = yystate;

                /*
                ** top of for (;;) loop while no reductions done
                */
        yy_stack:
                /*
                ** put a state and value onto the stacks
                */
#if YYDEBUG
                /*
                ** if debugging, look up token value in list of value vs.
                ** name pairs.  0 and negative (-1) are special values.
                ** Note: linear search is used since time is not a real
                ** consideration while debugging.
                */
                if ( yydebug )
                {
                        register int yy_i;

#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                        cout << "State " << yy_state << " token ";
                        if ( yychar == 0 )
                                cout << "end-of-file" << endl;
                        else if ( yychar < 0 )
                                cout << "-none-" << endl;
#else
                        printf( "State %d, token ", yy_state );
                        if ( yychar == 0 )
                                printf( "end-of-file\n" );
                        else if ( yychar < 0 )
                                printf( "-none-\n" );
#endif /* defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
                        else
                        {
                                for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
                                        yy_i++ )
                                {
                                        if ( yytoks[yy_i].t_val == yychar )
                                                break;
                                }
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                                cout << yytoks[yy_i].t_name << endl;
#else
                                printf( "%s\n", yytoks[yy_i].t_name );
#endif /* defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
                        }
                }
#endif /* YYDEBUG */
                if ( ++yy_ps >= &yys[ YYMAXDEPTH ] )    /* room on stack? */
                {
#ifndef YACC_MSG
                        yyerror( "yacc stack overflow" );
#else
                        yyerror(catgets(yyusercatd,1,2,"yacc stack overflow" ));
#endif
                        YYABORT;
                }
                *yy_ps = yy_state;
                *++yy_pv = yyval;

                /*
                ** we have a new state - find out what to do
                */
        yy_newstate:
                if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
                        goto yydefault;         /* simple state */
#if YYDEBUG
                /*
                ** if debugging, need to mark whether new token grabbed
                */
                yytmp = yychar < 0;
#endif
                if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
                        yychar = 0;             /* reached EOF */
#if YYDEBUG
                if ( yydebug && yytmp )
                {
                        register int yy_i;

#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                        cout << "Received token " << endl;
                        if ( yychar == 0 )
                                cout << "end-of-file" << endl;
                        else if ( yychar < 0 )
                                cout << "-none-" << endl;
#else
                        printf( "Received token " );
                        if ( yychar == 0 )
                                printf( "end-of-file\n" );
                        else if ( yychar < 0 )
                                printf( "-none-\n" );
#endif /* defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
                        else
                        {
                                for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
                                        yy_i++ )
                                {
                                        if ( yytoks[yy_i].t_val == yychar )
                                                break;
                                }
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                                cout << yytoks[yy_i].t_name << endl;
#else
                                printf( "%s\n", yytoks[yy_i].t_name );
#endif /* defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
                        }
                }
#endif /* YYDEBUG */
                if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
                        goto yydefault;
                if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )  /*valid shift*/
                {
                        yychar = -1;
                        yyval = yylval;
                        yy_state = yy_n;
                        if ( yyerrflag > 0 )
                                yyerrflag--;
                        goto yy_stack;
                }

        yydefault:
                if ( ( yy_n = yydef[ yy_state ] ) == -2 )
                {
#if YYDEBUG
                        yytmp = yychar < 0;
#endif
                        if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
                                yychar = 0;             /* reached EOF */
#if YYDEBUG
                        if ( yydebug && yytmp )
                        {
                                register int yy_i;

#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                                cout << "Received token " << endl;
                                if ( yychar == 0 )
                                        cout << "end-of-file" << endl;
                                else if ( yychar < 0 )
                                        cout << "-none-" << endl;
#else
                                printf( "Received token " );
                                if ( yychar == 0 )
                                        printf( "end-of-file\n" );
                                else if ( yychar < 0 )
                                        printf( "-none-\n" );
#endif /* defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
                                else
                                {
                                        for ( yy_i = 0;
                                                yytoks[yy_i].t_val >= 0;
                                                yy_i++ )
                                        {
                                                if ( yytoks[yy_i].t_val
                                                        == yychar )
                                                {
                                                        break;
                                                }
                                        }
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                                        cout << yytoks[yy_i].t_name << endl;
#else
                                        printf( "%s\n", yytoks[yy_i].t_name );
#endif /* defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
                                }
                        }
#endif /* YYDEBUG */
                        /*
                        ** look through exception table
                        */
                        {
                                register int *yyxi = yyexca;

                                while ( ( *yyxi != -1 ) ||
                                        ( yyxi[1] != yy_state ) )
                                {
                                        yyxi += 2;
                                }
                                while ( ( *(yyxi += 2) >= 0 ) &&
                                        ( *yyxi != yychar ) )
                                        ;
                                if ( ( yy_n = yyxi[1] ) < 0 )
                                        YYACCEPT;
                        }
                }

                /*
                ** check for syntax error
                */
                if ( yy_n == 0 )        /* have an error */
                {
                        /* no worry about speed here! */
                        switch ( yyerrflag )
                        {
                        case 0:         /* new error */
#ifndef YACC_MSG
                                yyerror( "syntax error" );
#else
                                yyerror(catgets(yyusercatd,1,3,"syntax error" ));
#endif
                                goto skip_init;
                        yyerrlab:
                                /*
                                ** get globals into registers.
                                ** we have a user generated syntax type error
                                */
                                yy_pv = yypv;
                                yy_ps = yyps;
                                yy_state = yystate;
                                yynerrs++;
                        skip_init:
                        case 1:
                        case 2:         /* incompletely recovered error */
                                        /* try again... */
                                yyerrflag = 3;
                                /*
                                ** find state where "error" is a legal
                                ** shift action
                                */
                                while ( yy_ps >= yys )
                                {
                                        yy_n = yypact[ *yy_ps ] + YYERRCODE;
                                        if ( yy_n >= 0 && yy_n < YYLAST &&
                                                yychk[yyact[yy_n]] == YYERRCODE)                                        {
                                                /*
                                                ** simulate shift of "error"
                                                */
                                                yy_state = yyact[ yy_n ];
                                                goto yy_stack;
                                        }
                                        /*
                                        ** current state has no shift on
                                        ** "error", pop stack
                                        */
#if YYDEBUG
                                        if ( yydebug )
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                                            cout << "Error recovery pops state "
                                                 << (*yy_ps)
                                                 << ", uncovers state "
                                                 << yy_ps[-1] << endl;
#else
#       define _POP_ "Error recovery pops state %d, uncovers state %d\n"
                                                printf( _POP_, *yy_ps,
                                                        yy_ps[-1] );
#       undef _POP_
#endif /* defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
#endif
                                        yy_ps--;
                                        yy_pv--;
                                }
                                /*
                                ** there is no state on stack with "error" as
                                ** a valid shift.  give up.
                                */
                                YYABORT;
                        case 3:         /* no shift yet; eat a token */
#if YYDEBUG
                                /*
                                ** if debugging, look up token in list of
                                ** pairs.  0 and negative shouldn't occur,
                                ** but since timing doesn't matter when
                                ** debugging, it doesn't hurt to leave the
                                ** tests here.
                                */
                                if ( yydebug )
                                {
                                        register int yy_i;

#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                                        cout << "Error recovery discards ";
                                        if ( yychar == 0 )
                                            cout << "token end-of-file" << endl;
                                        else if ( yychar < 0 )
                                            cout << "token -none-" << endl;
#else
                                        printf( "Error recovery discards " );
                                        if ( yychar == 0 )
                                                printf( "token end-of-file\n" );
                                        else if ( yychar < 0 )
                                                printf( "token -none-\n" );
#endif /* defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
                                        else
                                        {
                                                for ( yy_i = 0;
                                                        yytoks[yy_i].t_val >= 0;
                                                        yy_i++ )
                                                {
                                                        if ( yytoks[yy_i].t_val
                                                                == yychar )
                                                        {
                                                                break;
                                                        }
                                                }
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                                                cout << "token " <<
                                                    yytoks[yy_i].t_name <<
                                                    endl;
#else
                                                printf( "token %s\n",
                                                        yytoks[yy_i].t_name );
#endif /* defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
                                        }
                                }
#endif /* YYDEBUG */
                                if ( yychar == 0 )      /* reached EOF. quit */
                                        YYABORT;
                                yychar = -1;
                                goto yy_newstate;
                        }
                }/* end if ( yy_n == 0 ) */
                /*
                ** reduction by production yy_n
                ** put stack tops, etc. so things right after switch
                */
#if YYDEBUG
                /*
                ** if debugging, print the string that is the user's
                ** specification of the reduction which is just about
                ** to be done.
                */
                if ( yydebug )
#if defined(__cplusplus) && defined(_CPP_IOSTREAMS)
                        cout << "Reduce by (" << yy_n << ") \"" <<
                            yyreds[ yy_n ] << "\"\n";
#else
                        printf( "Reduce by (%d) \"%s\"\n",
                                yy_n, yyreds[ yy_n ] );
#endif /* defined(__cplusplus) && defined(_CPP_IOSTREAMS) */
#endif
                yytmp = yy_n;                   /* value to switch over */
                yypvt = yy_pv;                  /* $vars top of value stack */
                /*
                ** Look in goto table for next state
                ** Sorry about using yy_state here as temporary
                ** register variable, but why not, if it works...
                ** If yyr2[ yy_n ] doesn't have the low order bit
                ** set, then there is no action to be done for
                ** this reduction.  So, no saving & unsaving of
                ** registers done.  The only difference between the
                ** code just after the if and the body of the if is
                ** the goto yy_stack in the body.  This way the test
                ** can be made before the choice of what to do is needed.
                */
                {
                        /* length of production doubled with extra bit */
                        register int yy_len = yyr2[ yy_n ];

                        if ( !( yy_len & 01 ) )
                        {
                                yy_len >>= 1;
                                yyval = ( yy_pv -= yy_len )[1]; /* $$ = $1 */
                                yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
                                        *( yy_ps -= yy_len ) + 1;
                                if ( yy_state >= YYLAST ||
                                        yychk[ yy_state =
                                        yyact[ yy_state ] ] != -yy_n )
                                {
                                        yy_state = yyact[ yypgo[ yy_n ] ];
                                }
                                goto yy_stack;
                        }
                        yy_len >>= 1;
                        yyval = ( yy_pv -= yy_len )[1]; /* $$ = $1 */
                        yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
                                *( yy_ps -= yy_len ) + 1;
                        if ( yy_state >= YYLAST ||
                                yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
                        {
                                yy_state = yyact[ yypgo[ yy_n ] ];
                        }
                }
                                        /* save until reenter driver code */
                yystate = yy_state;
                yyps = yy_ps;
                yypv = yy_pv;
        }
        /*
        ** code supplied by user is placed in this switch
        */

                switch(yytmp){

case 2:
# line 92 "calc.y"
{ fprintf(dout, "%.8g\n", yypvt[-0]) ; } /*NOTREACHED*/ break;
case 3:
# line 95 "calc.y"
{ yyval = yypvt[-0] ; } /*NOTREACHED*/ break;
case 4:
# line 96 "calc.y"
{ yyval = -yypvt[-0] ; } /*NOTREACHED*/ break;
case 5:
# line 97 "calc.y"
{ yyval = yypvt[-2] + yypvt[-0] ; } /*NOTREACHED*/ break;
case 6:
# line 98 "calc.y"
{ yyval = yypvt[-2] - yypvt[-0] ; } /*NOTREACHED*/ break;
case 7:
# line 99 "calc.y"
{ yyval = yypvt[-2] * yypvt[-0] ; } /*NOTREACHED*/ break;
case 8:
# line 100 "calc.y"
{ yyval = yypvt[-2] / yypvt[-0] ; } /*NOTREACHED*/ break;
case 9:
# line 101 "calc.y"
{ yyval = (int)yypvt[-2] % (int)yypvt[-0] ; } /*NOTREACHED*/ break;
case 10:
# line 102 "calc.y"
{ yyval = pow(yypvt[-2], yypvt[-0]) ; } /*NOTREACHED*/ break;
case 11:
# line 103 "calc.y"
{ yyval = yypvt[-1] ; } /*NOTREACHED*/ break;
case 12:
# line 104 "calc.y"
{ yyval = (yypvt[-2] == yypvt[-0]) ; } /*NOTREACHED*/ break;
case 13:
# line 105 "calc.y"
{ yyval = (yypvt[-2] != yypvt[-0]) ; } /*NOTREACHED*/ break;
case 14:
# line 106 "calc.y"
{ yyval = (yypvt[-2] > yypvt[-0]) ; } /*NOTREACHED*/ break;
case 15:
# line 107 "calc.y"
{ yyval = (yypvt[-2] >= yypvt[-0]) ; } /*NOTREACHED*/ break;
case 16:
# line 108 "calc.y"
{ yyval = (yypvt[-2] < yypvt[-0]) ; } /*NOTREACHED*/ break;
case 17:
# line 109 "calc.y"
{ yyval = (yypvt[-2] <= yypvt[-0]) ; } /*NOTREACHED*/ break;
case 18:
# line 110 "calc.y"
{ yyval = yypvt[-2] || yypvt[-0] ; } /*NOTREACHED*/ break;
case 19:
# line 111 "calc.y"
{ yyval = yypvt[-2] && yypvt[-0] ; } /*NOTREACHED*/ break;
case 20:
# line 112 "calc.y"
{ yyval = yypvt[-4] ? yypvt[-2] : yypvt[-0] ; } /*NOTREACHED*/ break;
case 21:
# line 113 "calc.y"
{ yyval = fabs( yypvt[-1] ) ; } /*NOTREACHED*/ break;
case 22:
# line 114 "calc.y"
{ yyval = sqrt( yypvt[-1] ) ; } /*NOTREACHED*/ break;
case 23:
# line 115 "calc.y"
{ yyval = log( yypvt[-1] ) ; } /*NOTREACHED*/ break;
case 24:
# line 116 "calc.y"
{ yyval = exp( yypvt[-1] ) ; } /*NOTREACHED*/ break;
case 25:
# line 117 "calc.y"
{ yyval = sin( yypvt[-1] ) ; } /*NOTREACHED*/ break;
case 26:
# line 118 "calc.y"
{ yyval = cos( yypvt[-1] ) ; } /*NOTREACHED*/ break;
case 27:
# line 119 "calc.y"
{ yyval = tan( yypvt[-1] ) ; } /*NOTREACHED*/ break;
case 28:
# line 120 "calc.y"
{ yyval = sinh( yypvt[-1] ) ; } /*NOTREACHED*/ break;
case 29:
# line 121 "calc.y"
{ yyval = cosh( yypvt[-1] ) ; } /*NOTREACHED*/ break;
case 30:
# line 122 "calc.y"
{ yyval = tanh( yypvt[-1] ) ; } /*NOTREACHED*/ break;
case 31:
# line 123 "calc.y"
{ yyval = 1.0 / ( 1.0 + exp( -yypvt[-1] ) ) ; } /*NOTREACHED*/ break;
}


        goto yystack;           /* reset registers in driver code */
}

# line 125 "calc.y"

/* end of grammar */
/*********************************************************************/
static char	*parseString ;
/*********************************************************************/
typedef struct BuiltinPair {
  int	token ;
  char	*name ;
  int	length ;
} BuiltinPair ;
typedef struct OperatorPair {
  int	token ;
  char	*name ;
  int	length ;
} OperatorPair ;
/*********************************************************************/
static BuiltinPair builtin[] = { /* sizeof returns 3 for sizeof("ab") */
  { ABS,	"abs",		sizeof("abs") },
  { SQRT,	"sqrt",		sizeof("sqrt") },
  { LOG,	"log",		sizeof("log") },
  { EXP,	"exp",		sizeof("exp") },
  { TAN,	"tan",		sizeof("tan") },
  { COS,	"cos",		sizeof("cos") },
  { SIN,	"sin",		sizeof("sin") },
  { TANH,	"tanh",		sizeof("tanh") },
  { COSH,	"cosh",		sizeof("cosh") },
  { SINH,	"sinh",		sizeof("sinh") },
  { SIGMOID,	"sigmoid",	sizeof("sigmoid") }
} ;
/*********************************************************************/
static OperatorPair operator[] = { /* must be longest name first */
  { OR,		"||",		sizeof("||") },
  { AND,	"&&",		sizeof("&&") },
  { EQ,		"==",		sizeof("==") },
  { NE,		"!=",		sizeof("!=") },
  { LE,		"<=",		sizeof("<=") },
  { GE,		">=",		sizeof(">=") },
  { LT,		"<",		sizeof("<")  },
  { GT,		">",		sizeof(">")  }
} ;
/*********************************************************************
 *	Name:		yylex
 *	Description:	
 *	Parameters:
 *	Return Value:
 *	  int	yylex - 
 *********************************************************************/
int	yylex() 
{
  int	c, idx ;
  char	*ptr, buffer[112] ;

  /* make parseString point to first non-white-space character */
  for (c = *parseString ; isspace(c) ; c = *(++parseString))
    ;

  /* if end of string, bug out */
  if (c == '\0')
    return 0 ;

  /* check for a number */
  yylval = strtod(parseString, &ptr) ;
  if (ptr != parseString) {
    parseString = ptr ;
    return NUMBER ;
  }

#if 0
  /* check for operators */
  for (idx = 0 ; idx < sizeof(operator)/sizeof(*operator) ; ++idx) {
    if (strncmp(parseString, 
		operator[idx].name, strlen(operator[idx].name)) == 0) {
      parseString += strlen(operator[idx].name) ;
      return operator[idx].token ;
    }
  }

  /* check for builtin functions (must be alphabetics) */
  if (sscanf(parseString, "%[a-z]", buffer)) {
    for (idx = 0 ; idx < sizeof(builtin)/sizeof(*builtin) ; ++idx) {
      if (strcmp(buffer, builtin[idx].name) == 0) {
	parseString += strlen(builtin[idx].name) ;
	return builtin[idx].token ;
      }
    }
  }
#else
  /* check for operators */
  for (idx = 0 ; idx < sizeof(operator)/sizeof(*operator) ; ++idx) {
    if (strncmp(parseString, 
		operator[idx].name, operator[idx].length-1) == 0) {
      parseString += operator[idx].length - 1 ;
      return operator[idx].token ;
    }
  }

  /* check for builtin functions (must be alphabetics) */
  if (sscanf(parseString, "%[a-z]", buffer)) {
    for (idx = 0 ; idx < sizeof(builtin)/sizeof(*builtin) ; ++idx) {
      if (strcmp(buffer, builtin[idx].name) == 0) {
	parseString += builtin[idx].length - 1 ;
	return builtin[idx].token ;
      }
    }
  }
#endif
  
  /* just increment parseString and return the character otherwise */
  ++parseString ;
  return c ;
}
/********************************************************************/

/*********************************************************************
 *	Name:		yyerror
 *	Description:	
 *	Parameters:
 *	  va_dcl
 *	Return Value:
 *	  int	yyerror - 
 *********************************************************************/
int	yyerror(va_alist)
  va_dcl
{
  va_list	 ap;

#ifndef hpux
  yyerrok ;
#endif

  va_start(ap);
  IErrorV(&ap) ;
  IAbort() ;
  return 1 ;
}
/********************************************************************/


/*********************************************************************
 *	Name:		calc
 *	Description:	
 *	Parameters:
 *	  int	tokc - 
 *	  char	*tokvReturn Value:
 *	  int	command_calc - 
 *********************************************************************/
int	command_calc(tokc, tokv)
  int	tokc ;
  char	*tokv[] ;
{
  char	buffer[BUFSIZ] ;
  int	idx ;

  IUsage("<expr>");
  if (GiveHelp(tokc)) {
    ISynopsis("evaluate a floating point expression");
    IHelp
      (IHelpArgs,
       "The calc command  can  be used  to do evaluate simple floating point",
       "arithmetic expressions. The  result of the evaluation is  printed to",
       "the standard output. Expression syntax is very similar to C. Builtin",
       "operators include (in order of precedence):",
       "",
       "	-		unary minus",
       "	^		exponentiation",
       "	*, /, %		multiplication, division, modulo",
       "	+, -		addition, subtraction",
       "	<, <=, >, >=	less than, less than or equal, greater",
       "			than, greater than or equal",
       "	==, !=		equal, not equal",
       "	&&		logical AND",
       "	||		logical OR",
       "	? :		conditional expression",
       "",
       "As well, there are builtin functions for: abs,  sqrt, log, exp, tan,",
       "sin, cos, tanh, sinh, cosh, and sigmoid.",
       "EXAMPLES",
       "To cast a (0, 1) sigmoid onto (-1, 1), and print it:",
       "",
       "xerion-> calc '2.0 * sigmoid(1.0) - 1.0'",
       "0.46211716",
       "",
       "To print the maximum of the network cost and error:",
       "",
       "xerion-> calc \"${currentNet.error} > ${currentNet.cost} ? \\",
       "		${currentNet.error} : ${currentNet.cost}\"",
       "0.46211716",
       "To find the absolute value between a  unit's  target and output, you",
       "could use the following:",
       "",
       "xerion-> var Real output",
       "xerion-> var Real target",
       "xerion-> var Real diff",
       "xerion-> set output = ${currentNet.group[3].unit[0].output}",
       "xerion-> set target = ${currentNet.group[3].unit[0].target}",
       "xerion-> set diff   = `calc abs($output - $target)`",
       "xerion-> show diff",
       "	diff = 0.000139296",
       "",
       "SEE ALSO",
       "print, show, var, set",
       NULL);

    return 1;
  }
  
  buffer[0] = '\0' ;
  for (idx = 1 ; idx < tokc ; ++idx) {
    strcat(buffer, tokv[idx]) ;
    strcat(buffer, " ") ;
  }
  parseString = buffer ;

  yyparse() ;
  return 1 ;
}
/********************************************************************/

