
/*  A Bison parser, made from exampleParse.y
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	INTEGER	257
#define	REAL	258
#define	TAG	259
#define	FREQ	260
#define	INSTR	261
#define	ALL	262
#define	LAST	263
#define	NEXT	264
#define	REST	265
#define	UNARYMINUS	266

#line 1 "exampleParse.y"

/**********************************************************************
 * $Id: exampleParse.y,v 1.5 93/02/26 12:03:05 drew Exp $
 **********************************************************************/

/**********************************************************************
 *   Copyright 1990,1991,1992,1993 by The University of Toronto,
 *		      Toronto, Ontario, Canada.
 * 
 *			 All Rights Reserved
 * 
 * Permission to use, copy, modify, distribute, and sell this software
 * and its  documentation for  any purpose is  hereby granted  without
 * fee, provided that the above copyright notice appears in all copies
 * and  that both the  copyright notice  and   this  permission notice
 * appear in   supporting documentation,  and  that the  name  of  The
 * University  of Toronto  not  be  used in  advertising or  publicity
 * pertaining   to  distribution   of  the  software without specific,
 * written prior  permission.   The  University of   Toronto makes  no
 * representations  about  the  suitability of  this software  for any
 * purpose.  It  is    provided   "as is"  without express or  implied
 * warranty.
 *
 * THE UNIVERSITY OF TORONTO DISCLAIMS  ALL WARRANTIES WITH REGARD  TO
 * THIS SOFTWARE,  INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS, IN NO EVENT SHALL THE UNIVERSITY OF TORONTO  BE LIABLE
 * FOR ANY  SPECIAL, INDIRECT OR CONSEQUENTIAL  DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR  PROFITS, WHETHER IN
 * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
 * OUT  OF  OR  IN  CONNECTION WITH  THE  USE  OR PERFORMANCE  OF THIS
 * SOFTWARE.
 *
 **********************************************************************/

#include "exampleParse.h"

extern FILE	*yyin ;
extern int	yyparse() ;

static char	*tag ;
static char	*freq ;
static char	*instr ;
static int	nextIndex ;
static int	numSlices ;
static void	addRange() ;
static void	addValue() ;

static void	finishInputs() ;
static void	finishTargets() ;
static void	startNewExample() ;
static void	startNextVector() ;
static void	addExample() ;

static void	confirmVectorSize() ;


#line 57 "exampleParse.y"
typedef union {
  float	realValue ;
  char	stringValue[128] ;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		65
#define	YYFLAG		-32768
#define	YYNTBASE	19

#define YYTRANSLATE(x) ((unsigned)(x) <= 267 ? yytranslate[x] : 29)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,    14,    15,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,    18,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    12,     2,    13,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    16,    17
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     4,     8,    13,    18,    23,    29,    35,    41,
    48,    50,    52,    54,    56,    59,    62,    64,    67,    70,
    75,    81,    83,    87,    89,    92,    95,    97,   101,   103,
   106,   108,   110
};

static const short yyrhs[] = {    -1,
    19,    17,     0,    19,    23,    24,     0,    19,    20,    23,
    24,     0,    19,    21,    23,    24,     0,    19,    22,    23,
    24,     0,    19,    20,    21,    23,    24,     0,    19,    20,
    22,    23,    24,     0,    19,    21,    22,    23,    24,     0,
    19,    20,    21,    22,    23,    24,     0,     5,     0,     6,
     0,     7,     0,    14,     0,    27,    14,     0,    25,    14,
     0,    18,     0,    27,    18,     0,    25,    18,     0,    12,
    26,    13,    27,     0,    25,    12,    26,    13,    27,     0,
     3,     0,     3,    15,     3,     0,     8,     0,    10,     3,
     0,     9,     3,     0,    11,     0,    26,    14,    26,     0,
    28,     0,    27,    28,     0,     4,     0,     3,     0,    15,
    28,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    80,    81,    82,    84,    86,    88,    90,    92,    94,    96,
   100,   103,   106,   109,   110,   111,   114,   116,   118,   121,
   123,   127,   128,   129,   130,   132,   134,   135,   138,   139,
   142,   143,   144
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","INTEGER",
"REAL","TAG","FREQ","INSTR","ALL","LAST","NEXT","REST","'['","']'","','","'-'",
"UNARYMINUS","\"EOF\"","';'","exampleSet","exampleTag","exampleFreq","exampleInStr",
"inputList","targetList","vectorList","range","realVector","real", NULL
};
#endif

static const short yyr1[] = {     0,
    19,    19,    19,    19,    19,    19,    19,    19,    19,    19,
    20,    21,    22,    23,    23,    23,    24,    24,    24,    25,
    25,    26,    26,    26,    26,    26,    26,    26,    27,    27,
    28,    28,    28
};

static const short yyr2[] = {     0,
     0,     2,     3,     4,     4,     4,     5,     5,     5,     6,
     1,     1,     1,     1,     2,     2,     1,     2,     2,     4,
     5,     1,     3,     1,     2,     2,     1,     3,     1,     2,
     1,     1,     2
};

static const short yydefact[] = {     1,
     0,    32,    31,    11,    12,    13,     0,    14,     0,     2,
     0,     0,     0,     0,     0,     0,    29,    22,    24,     0,
     0,    27,     0,    33,     0,     0,     0,     0,     0,     0,
    17,     3,     0,     0,     0,    16,    15,    30,     0,    26,
    25,     0,     0,     0,     0,     0,     4,     0,     5,     6,
    19,    18,     0,    23,    20,    28,     0,     7,     8,     9,
     0,    10,    21,     0,     0
};

static const short yydefgoto[] = {     1,
    11,    12,    13,    14,    32,    15,    23,    16,    17
};

static const short yypact[] = {-32768,
    58,-32768,-32768,-32768,-32768,-32768,   107,-32768,   105,-32768,
    79,    85,    92,     0,    22,    98,-32768,     5,-32768,    36,
    40,-32768,    17,-32768,    85,    92,     0,    92,     0,     0,
-32768,-32768,   -10,    63,   107,-32768,-32768,-32768,    44,-32768,
-32768,   105,   107,    92,     0,     0,-32768,     0,-32768,-32768,
-32768,-32768,    42,-32768,   105,-32768,     0,-32768,-32768,-32768,
   105,-32768,   105,    45,-32768
};

static const short yypgoto[] = {-32768,
-32768,    46,    16,    -2,    23,    -8,   -30,   -13,    -9
};


#define	YYLAST		120


static const short yytable[] = {    24,
    34,    35,     2,     3,    53,    33,    38,    51,    27,    29,
    30,     7,    56,    34,     9,    34,    34,    31,    33,    39,
    33,    33,    45,    46,    38,    48,    26,    28,    55,    42,
    43,    34,    34,    35,    34,    36,    33,    33,    40,    33,
    44,    57,    41,    34,    65,    38,    54,    63,    33,    47,
     0,    49,    50,    38,    61,    43,    25,    64,     0,     0,
     2,     3,     4,     5,     6,     2,     3,    58,    59,     7,
    60,     8,     9,     0,    10,     0,     0,     9,     0,    62,
    52,     2,     3,     0,     5,     6,     0,     2,     3,     0,
     7,     6,     8,     9,     2,     3,     7,     0,     8,     9,
     2,     3,     0,     7,     0,     8,     9,     2,     3,    18,
     0,    37,     9,     0,    19,    20,    21,    22,     0,     9
};

static const short yycheck[] = {     9,
    14,    12,     3,     4,    35,    14,    16,    18,    11,    12,
    13,    12,    43,    27,    15,    29,    30,    18,    27,    15,
    29,    30,    25,    26,    34,    28,    11,    12,    42,    13,
    14,    45,    46,    12,    48,    14,    45,    46,     3,    48,
    25,    44,     3,    57,     0,    55,     3,    61,    57,    27,
    -1,    29,    30,    63,    13,    14,    11,     0,    -1,    -1,
     3,     4,     5,     6,     7,     3,     4,    45,    46,    12,
    48,    14,    15,    -1,    17,    -1,    -1,    15,    -1,    57,
    18,     3,     4,    -1,     6,     7,    -1,     3,     4,    -1,
    12,     7,    14,    15,     3,     4,    12,    -1,    14,    15,
     3,     4,    -1,    12,    -1,    14,    15,     3,     4,     3,
    -1,    14,    15,    -1,     8,     9,    10,    11,    -1,    15
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 3:
#line 82 "exampleParse.y"
{ tag = NULL ; freq = NULL ; instr = NULL ;
						  startNewExample() ; ;
    break;}
case 4:
#line 84 "exampleParse.y"
{ tag = NULL ; freq = NULL ; instr = NULL ;
						 startNewExample() ; ;
    break;}
case 5:
#line 86 "exampleParse.y"
{ tag = NULL ; freq = NULL ; instr = NULL ;
						 startNewExample() ; ;
    break;}
case 6:
#line 88 "exampleParse.y"
{ tag = NULL ; freq = NULL ; instr = NULL ;
						 startNewExample() ; ;
    break;}
case 7:
#line 90 "exampleParse.y"
{ tag = NULL ; freq = NULL ; instr = NULL ;
						 startNewExample() ; ;
    break;}
case 8:
#line 92 "exampleParse.y"
{ tag = NULL ; freq = NULL ; instr = NULL ;
						 startNewExample() ; ;
    break;}
case 9:
#line 94 "exampleParse.y"
{ tag = NULL ; freq = NULL ; instr = NULL ;
						 startNewExample() ; ;
    break;}
case 10:
#line 96 "exampleParse.y"
{ tag = NULL ; freq = NULL ; instr = NULL ;
						 startNewExample() ; ;
    break;}
case 11:
#line 100 "exampleParse.y"
{ tag = yyvsp[0].stringValue ; ;
    break;}
case 12:
#line 103 "exampleParse.y"
{ freq = yyvsp[0].stringValue ; ;
    break;}
case 13:
#line 106 "exampleParse.y"
{ instr = yyvsp[0].stringValue ; ;
    break;}
case 14:
#line 109 "exampleParse.y"
{ confirmVectorSize() ; finishInputs() ; ;
    break;}
case 15:
#line 110 "exampleParse.y"
{ confirmVectorSize() ; finishInputs() ; ;
    break;}
case 16:
#line 111 "exampleParse.y"
{ finishInputs() ; ;
    break;}
case 17:
#line 114 "exampleParse.y"
{  confirmVectorSize() ; 
				   finishTargets() ; addExample(tag,freq,instr) ; ;
    break;}
case 18:
#line 116 "exampleParse.y"
{  confirmVectorSize() ; 
				   finishTargets() ; addExample(tag,freq,instr) ; ;
    break;}
case 19:
#line 118 "exampleParse.y"
{ finishTargets() ; addExample(tag,freq,instr) ; ;
    break;}
case 20:
#line 121 "exampleParse.y"
{  confirmVectorSize() ; 
					    startNextVector() ; ;
    break;}
case 21:
#line 123 "exampleParse.y"
{  confirmVectorSize() ; 
					    startNextVector() ; ;
    break;}
case 22:
#line 127 "exampleParse.y"
{ addRange((int)yyvsp[0].realValue, (int)yyvsp[0].realValue) ; ;
    break;}
case 23:
#line 128 "exampleParse.y"
{ addRange((int)yyvsp[-2].realValue, (int)yyvsp[0].realValue) ; ;
    break;}
case 24:
#line 129 "exampleParse.y"
{ addRange(0, numSlices - 1) ; ;
    break;}
case 25:
#line 130 "exampleParse.y"
{ addRange(nextIndex,
					   nextIndex + (int)yyvsp[0].realValue - 1) ; ;
    break;}
case 26:
#line 132 "exampleParse.y"
{ addRange(numSlices - (int)yyvsp[0].realValue, 
					   numSlices - 1) ; ;
    break;}
case 27:
#line 134 "exampleParse.y"
{ addRange(nextIndex, numSlices - 1) ; ;
    break;}
case 29:
#line 138 "exampleParse.y"
{ addValue((double)yyvsp[0].realValue) ; ;
    break;}
case 30:
#line 139 "exampleParse.y"
{ addValue((double)yyvsp[0].realValue) ; ;
    break;}
case 33:
#line 144 "exampleParse.y"
{ yyval.realValue = -yyvsp[0].realValue ; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 147 "exampleParse.y"

#ifdef ALL
#undef ALL
#endif  
#include <stdio.h>
#include <ctype.h>
#include <xerion/useful.h>
#include <xerion/simulator.h>

typedef enum Mode {Input, Target} Mode ;

static Mode	mode ;
static Real	**inputArrays ;
static Real	**targetArrays ;
static Real	*nanInputArray ;
static Real	*nanTargetArray ;
static Real	*valueArray ;
static int	numValues, maxValues ;
static int	numInputs  ;
static int	numTargets ;

static ExampleSet	exampleSet ;

static Real	*getValueArray() ;
static void	allocateArrays() ;

int exampleFileLineNumber = 1 ;

/*********************************************************************
 *	Name:		yyerror
 *	Description:	Error mechanism for the parser
 *	Parameters:
 *	va_dcl		similar to printf (format, args ...)
 *	Return Value:
 *	  int	yyerror - actually, it aborts.
 *********************************************************************/
int	yyerror(va_alist)
va_dcl
{
  va_list	 ap;

#ifndef hpux
#ifdef linux
#else
  yyerrok ;
#endif
#endif


  va_start(ap);
  IErrorV(&ap) ;
  IError("Near line %d\n", exampleFileLineNumber) ;
  IAbort() ;
  return 1 ;
}
/********************************************************************/


/*********************************************************************
 *	Name:		readExampleFile
 *	Description:	reads in a file of examples and adds them to a
 *			set
 *	Parameters:
 *	  FILE		*fp - the file to read from
 *	  ExampleSet	set - the example set to add to
 *	  int		expectedSlices - the number of time slices in
 *				the net
 *	  int		expectedInputs - the number of input units in
 *				the net
 *	  int		expectedTargets - the number of target units
 *				in the net
 *	Return Value:
 *	  void	readExampleFile - NONE
 *********************************************************************/
void	readExampleFile(fp, set, 
			expectedSlices, expectedInputs, expectedTargets)
  FILE	*fp ;
  ExampleSet	set ;
  int	expectedSlices ;
  int	expectedInputs ;
  int	expectedTargets ;
{
  numSlices  = expectedSlices ;
  numInputs  = expectedInputs ;
  numTargets = expectedTargets ;
  exampleSet = set ;
  exampleFileLineNumber = 1 ;
  yyin = fp ;

  startNewExample() ;
  yyparse() ;
}
/********************************************************************/


/*********************************************************************
 *	Name:		addRange
 *	Description:	adds the current vector to the range of time
 *			slices
 *	Parameters:
 *	  int	low, high - the lowest and highest time slices to add
 *			the vector to (inclusive range)
 *	Return Value:
 *	  void	addRange - NONE
 *********************************************************************/
static void	addRange(low, high) 
  int	low, high ;
{
  Real	*value ;

  if (low < nextIndex)
    yyerror("range is not increasing: %d,%d", nextIndex, low) ;
  else if (low > high)
    yyerror("range is not increasing: %d-%d", low, high) ;
  else if (low > numSlices)
    yyerror("value too high: %d", low) ;
  else if (high > numSlices)
    yyerror("value too high: %d", high) ;

  value = getValueArray(mode) ;
  if (mode == Input) {
    while(low <= high) {
      if (inputArrays[low] != nanInputArray)
	yyerror("vector already specified for slice %d", low) ;
      inputArrays[low++] = value ;
    }
  } else {
    while(low <= high) {
      if (targetArrays[low] != nanTargetArray)
	yyerror("vector already specified for slice %d", low) ;
      targetArrays[low++] = value ;
    }
  }
  nextIndex = low ;
}
/********************************************************************/


/*********************************************************************
 *	Name:		addValue
 *	Description:	adds a value to the current vector
 *	Parameters:
 *	  float	value - the value to add
 *	Return Value:
 *	  void	addValue - NONE
 *********************************************************************/
static void	addValue(value) 
  double	value ;
{
  Real	*array ;

  array = getValueArray(mode) ;

  if (numValues >= maxValues)
    yyerror("too many values: %d", numValues) ;

  array[numValues++] = value ;
}
/********************************************************************/


/*********************************************************************
 *	Name:		startNewExample
 *	Description:	resets the example arrays, making it ready
 *			for a new list of examples
 *	Parameters:	NONE
 *	Return Value:
 *	  void	startNewExample - NONE
 *********************************************************************/
static void	startNewExample() {
  mode = Input ;
  allocateArrays() ;
  nextIndex = 0 ;
  startNextVector() ;
}
/********************************************************************/


/*********************************************************************
 *	Name:		finishInputs
 *	Description:	cleans up the input vectors before going
 *			on to targets
 *	Parameters:	NONE
 *	Return Value:
 *	  int	finishInputs - NONE
 *********************************************************************/
static void	finishInputs() {
  int	idx ;

  for (idx = 0 ; idx < numSlices ; ++idx)
    if (inputArrays[idx] != nanInputArray)
      break ;
  if (idx == numSlices)
    inputArrays[0] = getValueArray(mode) ;

  for (idx = 0 ; idx < numSlices ; ++idx)
    if (inputArrays[idx] == nanInputArray)
      break ;
  if (idx == numSlices)
    free(nanInputArray) ;

  mode = Target ;
  nextIndex = 0 ;
  startNextVector() ;
}
/********************************************************************/


/*********************************************************************
 *	Name:		finishTargets
 *	Description:	cleans up the target vectors before going
 *			on to the next example list
 *	Parameters:
 *	Return Value:
 *	  int	finishTargets - 
 *********************************************************************/
static void	finishTargets() 
{
  int	idx ;
  for (idx = 0 ; idx < numSlices ; ++idx)
    if (targetArrays[idx] != nanTargetArray)
      break ;
  if (idx == numSlices)
    targetArrays[numSlices - 1] = getValueArray(mode) ;

  for (idx = 0 ; idx < numSlices ; ++idx)
    if (targetArrays[idx] == nanTargetArray)
      break ;
  if (idx == numSlices)
    free(nanTargetArray) ;
}
/********************************************************************/


/*********************************************************************
 *	Name:		confirmVectorSize
 *	Description:	makes sure that the vector has enough values
 *	Parameters:	NONE
 *	Return Value:
 *	  static void	confirmVectorSize - NONE
 *********************************************************************/
static void	confirmVectorSize()
{
  if (mode == Input && numValues != numInputs)
    yyerror("Wrong number of input values") ;

  if (mode == Target && numValues != numTargets)
    yyerror("Wrong number of target values") ;
}
/********************************************************************/

    
/*********************************************************************
 *	Name:		startNextVector
 *	Description:	sets values so that we will be ready to read
 *			in a new vector.
 *	Parameters:	NONE
 *	Return Value:
 *	  void	startNextVector - NONE
 *********************************************************************/
static void	startNextVector() 
{
  valueArray = NULL ;
  numValues = 0 ;
}
/********************************************************************/


/*********************************************************************
 *	Name:		allocateArrays
 *	Description:	allocates the arrays for the example vectors
 *	Parameters:	NONE
 *	Return Value:
 *	  static void	allocateArrays - NONE
 *********************************************************************/
static void	allocateArrays() {
  int		idx ;

  inputArrays    = (Real **)calloc(numSlices,  sizeof(*inputArrays)) ;
  targetArrays   = (Real **)calloc(numSlices,  sizeof(*targetArrays)) ;
  
  nanInputArray  = (Real *)calloc(numInputs,  sizeof(*nanInputArray)) ;
  for (idx = 0 ; idx < numInputs ; ++idx)
    setNaN(nanInputArray[idx]) ;

  nanTargetArray = (Real *)calloc(numTargets, sizeof(*nanTargetArray)) ;
  for (idx = 0 ; idx < numTargets ; ++idx)
    setNaN(nanTargetArray[idx]) ;

  for (idx = 0 ; idx < numSlices ; ++idx) {
    inputArrays[idx]  = nanInputArray ;
    targetArrays[idx] = nanTargetArray ;
  }
}
/********************************************************************/


/*********************************************************************
 *	Name:		getValueArray
 *	Description:	returns the array of values, allocating it if
 *			necessary.
 *	Parameters:
 *	  Mode		mode - Input or Target
 *	Return Value:
 *	  static Real	*getValueArray - the array.
 *********************************************************************/
static Real	*getValueArray(arrayMode) 
  Mode		arrayMode ;
{
  int	idx, numElements ;

  if (valueArray == NULL) {
    if (arrayMode == Input)
      numElements = numInputs ;
    else
      numElements = numTargets ;

    maxValues = numElements ;
    valueArray = (Real *)calloc(numElements, sizeof(*valueArray)) ;
    for (idx = 0 ; idx < numElements ; ++idx)
      setNaN(valueArray[idx]) ;
  }
  
  return valueArray ;
}
/********************************************************************/


/*********************************************************************
 *	Name:		addExample
 *	Description:	adds an example to the already set exampleSet
 *	Parameters:	NONE
 *	Return Value:
 *	  static void	addExample - NONE
 *********************************************************************/
static void	addExample(name,sfreq,sinstr) 
  char		*name ;
  char		*sfreq ;
  char		*sinstr ;
{
  int	idx ;
  idx = exampleSetAddExampleList(exampleSet, numSlices,
				 inputArrays, numInputs,
				 targetArrays, numTargets) ;
  if (idx >= 0) {
    if (tag)  exampleSet->example[idx].name      = strdup(tag) ;
    if (freq) exampleSet->example[idx].frequency = atof(sfreq) ;
    if (instr) exampleSet->example[idx].inStrength = atof(sinstr) ;
  }
}
/********************************************************************/
