
/* articulatory to acoustic mapping constants */
#define	NUM_ARTIC_DFS		6
#define	NUM_ACOUSTIC_DFS	9

#define Mrange01(num)	((num+1.0)/2.0)
#define Mrange11(num)	((num*2.0)-1.0)
#define MinRange01(num) ((num >= 0.0 && num <= 1.001) ? TRUE : FALSE)
#define MinRange11(num) ((num >= -1.001 && num <= 1.001) ? TRUE : FALSE)
#define Mbow1(val,amount)	((1.0 - pow( (1.0-val), (Real)amount )))

#define MrandomExampleType(net)	((net)->extension->randomExampleType)
#define MrandomMagnitude(net) 	((net)->extension->randomMagnitude)
#define MgaussianSigma(net)	((net)->extension->gaussianSigma)
#define MgaussianScale(net)	((net)->extension->gaussianScale)
#define Manticipate(net)	((net)->extension->anticipate)
#define Mperseverate(net)	((net)->extension->perseverate)
#define MprobNewInput(net)	((net)->extension->probNewInput)

#define MgaussianSize(group)	((group)->extension->gaussianSize)
#define MgatingUnit(group)	((group)->extension->gatingUnit)
#define MgaussianBuffer(group)	((group)->extension->gaussianBuffer)

extern Proc	netOutcomeDistort4bit	ARGS((Net net)) ;
extern Proc	netOutcomeAcoustics	ARGS((Net net)) ;
extern Proc	netOutcomeID		ARGS((Net net)) ;
extern Proc	netOutcomeGaussID	ARGS((Net net)) ;

extern void	makeRandomExample	ARGS((Net net, Example example)) ;
extern int	computeAcousticGoals	ARGS((Net net, Example example)) ;
extern void	computeGaussianIDgoal	ARGS((Net net, Example example)) ;
extern void	forwardArticNormalized  ARGS((Net net, Group group)) ;
extern void	distort4bit		ARGS((Net net)) ;

extern int	copiedFromLayer		ARGS((Net net, int groupNum)) ;






